<template>
  <div id="divId_MonthlyVolumeSAF">
    <!-- Plotly chart will be drawn inside this DIV -->
  </div>
  <div>
    <Datepicker v-model="fromDate">Da</Datepicker>
    <Datepicker v-model="toDate">A</Datepicker>
    <button v-on:click="filterByDate">Apply filter and recalculate</button>
    <Plotly/>
  </div>
</template>

<script>
import Plotly from "plotly.js-dist";

export default {
  data() {
    return {
      infos_queries: [],
      disabled: { to: null, from: null },
      fromDate: new Date(2010, 1, 1),
      toDate: Date.now(),
      plotly_data: [],
    };
  },

  methods: {
    async getData() {
      try {
        const response = await this.axios.get("http://localhost:8080/monthly_volume_saf");
        // JSON responses are automatically parsed.
        this.infos_queries = response.data;
        this.fillPlotlyData();
        this.createPlotly();
      } catch (error) {
        console.log(error);
      }
    },
    filterByDate() {
      let xList = [];
      let yList = [];
      for (let entry of this.infos_queries) {
        let date = new Date(entry.MONTHDATE).getTime();
        let toDate = new Date(this.toDate).getTime();
        let fromDate = new Date(this.fromDate).getTime();
        if (toDate <= fromDate) {
          alert("-----la data da deve essere inferiore alla data a --");
          return null;
        }
        if (date >= fromDate && date <= toDate) {
          console.log("----date=", date, fromDate, toDate);
          xList.push(entry.MONTHDATE);
          yList.push(entry.NBR_QUERIES);
        }
      }
      this.plotly_data[0].x = xList;
      this.plotly_data[0].y = yList;
      Plotly.redraw("divId_MonthlyVolumeSAF");
    },
    createEmptyTrace(traceName, color) {
      let trace = {
        name: traceName,
        x: [],
        y: [],

        type: "line",
        marker: {
          color: color,
        },
      };    
      return trace1;      
    },
    fillPlotlyData() {
      let trace1 = {
        name: "Nbr Queries",
        x: [],
        y: [],

        type: "line",
        marker: {
          color: "#270657",
        },
      };

      for (const info of this.infos_queries) {
        trace1.x.push(info.MONTHDATE);
        trace1.y.push(info.NBR_QUERIES);
      }

      this.plotly_data = [trace1];
    },
    createPlotly() {
      let layout = {
        showlegend: true,
        yaxis2: {
          type: "category",
          side: "right",
          overlaying: "y",
        },
      };

      Plotly.newPlot("divId_MonthlyVolumeSAF", this.plotly_data, layout, {
        responsive: true,
        displaylogo: true,
      });
    },
  },
  created() {
    this.getData();
  },
};
</script>
